package uk.co.javahelp.maven.plugin.fitnesse.mojo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on fitnesse-launcher-maven-plugin.<br/> Call <pre>  mvn fitnesse:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Tue Jun 05 22:33:01 BST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "uk.co.javahelp.fitnesse:fitnesse-launcher-maven-plugin:1.0.0", 0 );
        append( sb, "", 0 );

        append( sb, "FitNesse Launcher Plugin", 0 );
        append( sb, "Provides ability to launch FitNesse as a wiki server, or automatically run FitNesse tests as part of a standard integration-test / verify build. Allows configuration of FitNesse\'s classpath through plugin dependencies, and injects all Maven project properties as FitNesse variables, ( which can be overridden from the command line using \'-D\' ).", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 5 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "fitnesse:help", 0 );
            append( sb, "Display help information on fitnesse-launcher-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0fitnesse:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run-tests".equals( goal ) )
        {
            append( sb, "fitnesse:run-tests", 0 );
            append( sb, "Goal that runs FitNesse tests using fitnesse.junit.TestHelper. Intended to be bound to the \'integration-test\' phase.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "createSymLink", 2 );
                append( sb, "fitnesse-launcher-maven-plugin unpacks a fresh copy of FitNesse under /target; Only your project specific FitNesse tests need go under src/test/fitnesse. By setting \'createSymLink\' to \'true\', fitnesse-launcher-maven-plugin will create a FitNesse SymLink directly to your test suite under src/test/fitnesse. This is most useful when developing tests in \'wiki\' mode, as then you can directly scm commit your changes. If you prefer to copy-resources from src/test/fitnesse into /target/fitnesse, let \'createSymLink\' be \'false\'.", 3 );
                append( sb, "Expression: ${fitnesse.createSymLink}", 3 );
                append( sb, "", 0 );

                append( sb, "excludeSuiteFilter", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.excludeSuiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "logDir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.logDir}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginDescriptor", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 9123)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.port}", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "Maven project, to be injected by Maven itself.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project}", 3 );
                append( sb, "", 0 );

                append( sb, "reportsDir (Default: ${fitnesse.working}/reports)", 2 );
                append( sb, "This is where build results go.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "resultsDir (Default: ${fitnesse.working}/results)", 2 );
                append( sb, "This is where build results go.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "root (Default: FitNesseRoot)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.root}", 3 );
                append( sb, "", 0 );

                append( sb, "suite", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.suite}", 3 );
                append( sb, "", 0 );

                append( sb, "suiteFilter", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.suiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "summaryFile", 2 );
                append( sb, "The summary file to write integration test results to.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${fitnesse.working}/results/failsafe-summary.xml", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.test}", 3 );
                append( sb, "", 0 );

                append( sb, "testResourceDirectory (Default: src/test/fitnesse)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.test.resource.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDir (Default: ${project.build.directory}/fitnesse)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.working}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "shutdown".equals( goal ) )
        {
            append( sb, "fitnesse:shutdown", 0 );
            append( sb, "Goal that shuts down FitNesse. This is done by sending GET to http://localhost:<port>/?responder=shutdown.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "port (Default: 9123)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.port}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "verify".equals( goal ) )
        {
            append( sb, "fitnesse:verify", 0 );
            append( sb, "Goal that provides summary report on FitNesse tests run with \'run-tests\' goal. Intended to be bound to the \'verify\' phase. Will fail the build if there are test failures.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "createSymLink", 2 );
                append( sb, "fitnesse-launcher-maven-plugin unpacks a fresh copy of FitNesse under /target; Only your project specific FitNesse tests need go under src/test/fitnesse. By setting \'createSymLink\' to \'true\', fitnesse-launcher-maven-plugin will create a FitNesse SymLink directly to your test suite under src/test/fitnesse. This is most useful when developing tests in \'wiki\' mode, as then you can directly scm commit your changes. If you prefer to copy-resources from src/test/fitnesse into /target/fitnesse, let \'createSymLink\' be \'false\'.", 3 );
                append( sb, "Expression: ${fitnesse.createSymLink}", 3 );
                append( sb, "", 0 );

                append( sb, "excludeSuiteFilter", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.excludeSuiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "logDir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.logDir}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginDescriptor", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 9123)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.port}", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "Maven project, to be injected by Maven itself.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project}", 3 );
                append( sb, "", 0 );

                append( sb, "reportsDir (Default: ${fitnesse.working}/reports)", 2 );
                append( sb, "This is where build results go.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "resultsDir (Default: ${fitnesse.working}/results)", 2 );
                append( sb, "This is where build results go.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "root (Default: FitNesseRoot)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.root}", 3 );
                append( sb, "", 0 );

                append( sb, "suite", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.suite}", 3 );
                append( sb, "", 0 );

                append( sb, "suiteFilter", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.suiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "summaryFile", 2 );
                append( sb, "The summary file to write integration test results to.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${fitnesse.working}/results/failsafe-summary.xml", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.test}", 3 );
                append( sb, "", 0 );

                append( sb, "testResourceDirectory (Default: src/test/fitnesse)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.test.resource.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDir (Default: ${project.build.directory}/fitnesse)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.working}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "wiki".equals( goal ) )
        {
            append( sb, "fitnesse:wiki", 0 );
            append( sb, "Goal that launches FitNesse as a wiki server. Useful for manually running / developing / debugging FitNesse tests. Once launched, just visit http://localhost:<port>/<suite>. Use the \'shutdown\' goal (from a different command line), or Ctrl+C to shutdown, or send GET to http://localhost:<port>/?responder=shutdown.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "createSymLink", 2 );
                append( sb, "fitnesse-launcher-maven-plugin unpacks a fresh copy of FitNesse under /target; Only your project specific FitNesse tests need go under src/test/fitnesse. By setting \'createSymLink\' to \'true\', fitnesse-launcher-maven-plugin will create a FitNesse SymLink directly to your test suite under src/test/fitnesse. This is most useful when developing tests in \'wiki\' mode, as then you can directly scm commit your changes. If you prefer to copy-resources from src/test/fitnesse into /target/fitnesse, let \'createSymLink\' be \'false\'.", 3 );
                append( sb, "Expression: ${fitnesse.createSymLink}", 3 );
                append( sb, "", 0 );

                append( sb, "excludeSuiteFilter", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.excludeSuiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "logDir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.logDir}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginDescriptor", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${plugin}", 3 );
                append( sb, "", 0 );

                append( sb, "port (Default: 9123)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.port}", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "Maven project, to be injected by Maven itself.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project}", 3 );
                append( sb, "", 0 );

                append( sb, "reportsDir (Default: ${fitnesse.working}/reports)", 2 );
                append( sb, "This is where build results go.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "resultsDir (Default: ${fitnesse.working}/results)", 2 );
                append( sb, "This is where build results go.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "root (Default: FitNesseRoot)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.root}", 3 );
                append( sb, "", 0 );

                append( sb, "suite", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.suite}", 3 );
                append( sb, "", 0 );

                append( sb, "suiteFilter", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.suiteFilter}", 3 );
                append( sb, "", 0 );

                append( sb, "summaryFile", 2 );
                append( sb, "The summary file to write integration test results to.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${fitnesse.working}/results/failsafe-summary.xml", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.test}", 3 );
                append( sb, "", 0 );

                append( sb, "testResourceDirectory (Default: src/test/fitnesse)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.test.resource.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "workingDir (Default: ${project.build.directory}/fitnesse)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${fitnesse.working}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
